





#include "WagnisPlayer.h"
#include <vector>
#include <string>

namespace orxonox
{
    RegisterClass(WagnisPlayer);

    //Constructor
    WagnisPlayer::WagnisPlayer(Context* context) : HumanPlayer(context){
        RegisterObject(WagnisPlayer);
        this->origin = nullptr;
        this->target = nullptr;
        this->gameBoard = nullptr;
    }
    //Destructor
    WagnisPlayer::~WagnisPlayer(){

    }
    //Manages a Players turn
    void WagnisPlayer::playerTurn(){
        
    }
    //checks if a move is valid, possible MoveTypes: ATTACK, MOVE, SET_TROOPS, SET_TROOPS_INITIAL
    bool WagnisPlayer::checkMove(WagnisProvince*,WagnisProvince*,MoveType move_type)
    {
        if (move_type == ATTACK)
        {
            if (isNeighbour(this->origin, this->target))//TODO: provinces neighbours
            {
                if (this->origin->getOwner_ID() == this->Player_ID) //origin belongs to player
                {
                    if (this->target->getOwner_ID() != this->Player_ID)//target belongs to enemy
                        return true;
                }
            }
        }

        if (move_type == MOVE)
        {
            if (existPath(this->origin, this->target))//TODO: path exists, all belong to same player
            {
                if (this->origin->getOwner_ID() == this->Player_ID)//origin belongs to player
                    return true;
            }

        }

        if (move_type == SET_TROOPS)
        {
            if (this->target->getOwner_ID() == this->Player_ID)//target belongs to player
                return true;
        }

        if (move_type == SET_TROOPS_INITIAL)
        {
            if (this->target->getOwner_ID() == 0)//target belongs to nobody
                return true;
        }
        
        return false;
    }
    
    //
    void WagnisPlayer::setTroops(WagnisProvince*){

    }
    void WagnisPlayer::attack(WagnisProvince*,WagnisProvince*){

    }
    void WagnisPlayer::moveTroops(WagnisProvince*,WagnisProvince*){

    }
    //Return a "Player x" String
    std::string WagnisPlayer::toString(){
        std::string str = "Player ";
        str.append(std::to_string(Player_ID));
        return str;
    }

    //private function for CheckMove
    //checks if provinces are neighbours for move
    bool WagnisPlayer::isNeighbour(WagnisProvince*,WagnisProvince*)
    {
        for (unsigned int i = 0; i < this->origin->neighbors.size(); ++i)
        {
            if (this->target == this->origin->neighbors[i])
                return true;
        }

        return false;
    }

    //private function for CheckMove
    //checks if path is complete with provinces owned by player
    bool WagnisPlayer::existPath(WagnisProvince*,WagnisProvince*)
    {
        if (this->origin->getOwner_ID() == this->target->getOwner_ID() && isNeighbour(this->origin, this->target))
            return true;
        
        for (unsigned int i = 0; i < this->origin->neighbors.size(); ++i)
        {
            if (this->origin->getOwner_ID() == this->origin->neighbors[i]->getOwner_ID())
                return existPath(this->origin->neighbors[i], this->target);
        }
            
        return false;
    }
}
